/*
 * Copyright (c) 2007, Ryo Ichinose
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 *
 *    * Redistributions of source code must retain the above copyright 
 *      notice, this list of conditions and the following disclaimer.
 *    * Redistributions in binary form must reproduce the above copyright 
 *      notice, this list of conditions and the following disclaimer in the 
 *      documentation and/or other materials provided with the distribution.
 *    * Neither the name of the auther nor the 
 *      names of its contributors may be used to endorse or promote products 
 *      derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <util/delay.h>
#include "util.h"


void
delay_250ms(void)
{
	int i;

	for (i = 0; i < 25; i ++) {
		_delay_ms(10);
	}
}


void 
delay_500ms(void)
{
	int i;

	for (i = 0; i < 50; i ++) {
		_delay_ms(10);
	}
}


#define INT64_MAX_DIGIT 20

int 
itoa(char *buf, int target, int base, int width, char pad)
{
	char tmpbuf[INT64_MAX_DIGIT + 1];
	char *tmppos = tmpbuf;
	char *pos = buf;
	char *left;
	char *right;
	char swap;
	char ch;
	int  length = 0;
	int  i;

	do {
		*(tmppos ++) = "0123456789abcdef"[target % base];
		length ++;
	}
	while (target /= base);

	*tmppos = '\0';
	left = tmpbuf;
	right = tmppos - 1;

	while (left < right) {
		swap = *left;
		*(left ++) = *right;
		*(right --) = swap;
	}

	for (i = 0; i < width - length; i ++) {
		*(pos ++) = pad;
	}

	tmppos = tmpbuf;

	while ((ch = *(tmppos ++))) {
		*(pos ++) = ch;
	}

	*pos = '\0';
	return (width > length) ? width : length;
}

/* End of util.c */
